#import  "MonoCtr.h"
#import  <appkit/Control.h>
#import  "../common.h"
#import  "MonotoneView.h"
#import  "imageOperation.h"
#import  "../ImageOpCtr.h"
#import  "../ImageOpr.h"

static void monoScale(float contr, float bright, unsigned char *buf)
{
	float	a, b;
	int	i, v;

	if (contr == 0.0) a = 1.0;
	else if (contr > 0.0)
		a = (contr < 1.0) ? (1.0 / (1.0 - contr)) : 512.0;
	else
		a = 1.0 - (contr * contr);
	b = bright * bright;
	if (bright < 0.0) b *= -1.0;
	b = (-1.0 - a) * 128.0 * (1.0 - b) + 256.0;

	for (i = 0; i < 256; i++) {
		v = (int)(a * i + b);
		buf[i] = (v > 255) ? 255 : ((v < 0) ? 0 : v);
	}
}


@implementation MonoCtr

- init
{
	int i;

	for (i = 0; i < 256; i++)
		tone[i] = i;
	return self;
}

- changeValue: sender
{
	monoScale([contrSlider floatValue], [brightSlider floatValue], tone);
	[monoView setTone: tone];
	[monoView display];
	return self;
}

- reset: sender
{
	int i;

	[contrSlider setFloatValue: 0.0];
	[brightSlider setFloatValue: 0.0];
	for (i = 0; i < 256; i++)
		tone[i] = i;
	[monoView setTone: tone];
	[monoView display];
	return self;
}

- monochrome: sender
{
	static int monokind[] = { Monochrome, Gray2Bits, BiLevel };

	[imageOpCtr monochrome: monokind[[sender selectedTag]]
		tone: tone method:[ditherSW selectedTag]];
	/* This message will be delegated to ImageOpr */
	return self;
}

- changeBrightness: sender
{
	[imageOpCtr brightness: tone];
	/* This message will be delegated to ImageOpr */
	return self;
}

@end
