#import  "TVController.h"
#import  <appkit/Application.h>
#import  <appkit/publicWraps.h>
#import  <appkit/Control.h>
#import  <appkit/MenuCell.h>
#import  <appkit/workspaceRequest.h>
#import  <objc/NXBundle.h>	/* LocalizedString */
#import  <defaults/defaults.h>
#import  <stdio.h>
#import  <stdlib.h>
#import  <string.h>
#import  <bsd/libc.h>
#import  <mach/mach_init.h>
#import  "ToyWin.h"
#import  "ToyView.h"
#import  "BackgCtr.h"
#import  "common.h"
#import  "strfunc.h"

@implementation TVController (BackgroundManager)


/* Local Method */
- loadBackgBundle
{
	char bdir[MAXFILENAMELEN];
	id bundle;
	int n;
	static id classBackg = nil;

	if (classBackg)
		return self;
	n = dircopy(bdir, NXArgv[0], YES);
	strcpy(&bdir[n], "BackgCtr.bundle");
	bundle = [[NXBundle alloc] initForDirectory: bdir];
	if (bundle == nil) /* ERROR */
		return nil;
	classBackg = [bundle classNamed:"BackgCtr"];
	if (classBackg == nil) /* ERROR */
		return nil;
	backgCtr = [(BackgCtr *)[classBackg alloc] init];
	return self;
}


- cleanBackground: sender
{
	if (backgCtr == nil || [backgCtr cleanBackground: sender] == nil)
		NXBeep();
	return self;
}

- backgMenuEnabled:(BOOL)flag
{
	[menuToFront setEnabled: flag];
	[menuClear setEnabled: flag];
	return self;
}

- makeFront: sender
{
	if (backgCtr == nil || [backgCtr makeFront: sender] == nil)
		NXBeep();
	return self;
}

- backWinFront: (BOOL)flag
{
	const char *title;

	if (flag)
		title = NXLocalizedString("Send to Back", NULL, Background);
	else
		title = NXLocalizedString("Bring to Front", NULL, Background);
	[menuToFront setTitle: title];
	return self;
}

- makeBackground: sender
{
	NXRect	*ir;
	id	tw, tv;
	commonInfo *cinf;
	int method = [sender selectedTag];
	
	if ((tw = [self keyWindow]) == nil) {
		NXBeep();
		return self;
	}
	tv = [tw toyView];
	if (backgCtr == nil)
		[self loadBackgBundle];
	cinf = [tv commonInfo];
	ir = [tv selectedRect];
	if (ir->size.width > 0.0 && ir->size.height > 0.0) {
		id tmp = [[NXImage alloc] initFromImage:[tv image] rect:ir];
		[backgCtr setImage: tmp hasAlpha: cinf->alpha with: method];
		[tmp free];
	}else
		[backgCtr setImage: [tv image] hasAlpha: cinf->alpha with: method];
	return self;
}

@end
